<?php
/*
Modle du script : ss_host_disk.php
Modifications : Jrme DESCOUX (Jaguar Network - AS30781) <jerome.descoux@as30781.net>
Date : 30 juin 2006
Objet : Ce script a pour but de grapher des sessions de peering utilisant le mac-accounting.

*** On Cisco 7200 ***
Router# conf t
Router(config)# interface gi0/1
Router(config-if)# ip accounting mac-address input
Router(config-if)# ip accounting mac-address output
Router(config-if)# exit
Router(config)# exit
*** 

Cacti tabli alors la liste des AS qui peer avec le notre et en ressort les graphiques.

Notes: Le code est assez "sale" mais je ne suis pas dveloppeur ^^. J'ai fais ce script par
envie et surtout par ncessit. Si quelqu'un se sent de le modifier, merci de m'en informer :).
*/

$no_http_headers = true;

/* display No errors */
error_reporting(E_ERROR);

include_once(dirname(__FILE__) . "/../lib/snmp.php");

if (!isset($called_by_script_server)) {
	include_once(dirname(__FILE__) . "/../include/config.php");
	array_shift($_SERVER["argv"]);
	print call_user_func_array("ss_host_mac", $_SERVER["argv"]);
}

function macaddr($PhysAddress) {
$mac=explode(":",$PhysAddress);
for ($ii=0;$ii<=5;$ii++) {
$mac[$ii]=@hexdec($mac[$ii]);
}
$adrmac=join(".",$mac);
return $adrmac;
}

function ss_host_mac($hostname, $host_id, $snmp_auth, $cmd, $arg1 = "", $arg2 = "") {
	$snmp = explode(":", $snmp_auth);
	$snmp_version = $snmp[0];
	$snmp_port = $snmp[1];
	$snmp_timeout = $snmp[2];

	$snmpv3_auth_username = "";
	$snmpv3_auth_password = "";
	$snmpv3_auth_protocol = "";
	$snmpv3_priv_passphrase = "";
	$snmpv3_priv_protocol = "";
	$snmp_community = "";

	if ($snmp_version == 3) {
		$snmpv3_auth_username = $snmp[4];
		$snmpv3_auth_password = $snmp[5];
		$snmpv3_auth_protocol = $snmp[6];
		$snmpv3_priv_passphrase = $snmp[7];
		$snmpv3_priv_protocol = $snmp[8];
	}else{
		$snmp_community = $snmp[3];
	}

	$oids = array(
		"index" => "1.3.6.1.2.1.15.3.1.7"
		);

	# how many interfaces
	$maxif=@snmpget($hostname, $snmp_community, "1.3.6.1.2.1.2.1.0");
	if ($maxif == FALSE) die("No MAXIF defined");
	$maxif=eregi_replace("INTEGER: ","",$maxif);

	switch ($cmd) {
		case "index":
			$return_arr = ss_host_mac_reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["index"], $snmp_version, $snmpv3_auth_username, $snmpv3_auth_password, $snmp_port, $snmp_timeout, SNMP_POLLER));

			for ($i=0;($i<sizeof($return_arr));$i++) {
				for ($a=0;$a<=$maxif;$a++) {
					$errorgetmac=false;
					$monoid="1.3.6.1.2.1.4.22.1.2.".$a.".".$return_arr[$i];
					$PhysAddress=@snmpget($hostname, $snmp_community, $monoid);
					if ($PhysAddress == FALSE) $errorgetmac=true;
					if ($errorgetmac == false) {
						print $return_arr[$i]."\n"; break;
					}
				}
			}
		break;

		case "query":
			$arg = $arg1;

				$arr_index = ss_host_mac_reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["index"], $snmp_version, $snmpv3_auth_username, $snmpv3_auth_password, $snmp_port, $snmp_timeout, SNMP_POLLER));

			switch ($arg) {
				case "hostname":
					for ($i=0;($i<sizeof($arr_index));$i++) {
						for ($a=0;$a<=$maxif;$a++) {
							$errorgetmac=false;
							$monoid="1.3.6.1.2.1.4.22.1.2.".$a.".".$arr_index[$i];
							$PhysAddress=@snmpget($hostname, $snmp_community, $monoid);
							if ($PhysAddress == FALSE) $errorgetmac=true;
							if ($errorgetmac == false) {
								print $arr_index[$i] . "!" . gethostbyaddr($arr_index[$i]) . "\n";
							}
						}
					}
				break;

				case "index":
					for ($i=0;($i<sizeof($arr_index));$i++) {
						for ($a=0;$a<=$maxif;$a++) {
							$errorgetmac=false;
							$monoid="1.3.6.1.2.1.4.22.1.2.".$a.".".$arr_index[$i];
							$PhysAddress=@snmpget($hostname, $snmp_community, $monoid);
							if ($PhysAddress == FALSE) $errorgetmac=true;
							if ($errorgetmac == false) {
								print $arr_index[$i] . "!" .$arr_index[$i]."\n";
							}
						}
					}
				break;
	
				case "as":
					for ($i=0;($i<sizeof($arr_index));$i++) {
						for ($a=0;$a<=$maxif;$a++) {
							$errorgetmac=false;
							$monoid="1.3.6.1.2.1.4.22.1.2.".$a.".".$arr_index[$i];
							$PhysAddress=@snmpget($hostname, $snmp_community, $monoid);
							if ($PhysAddress == FALSE) $errorgetmac=true;
							if ($errorgetmac == false) {
								$as=eregi_replace("INTEGER: ","",@snmpget($hostname, $snmp_community, ".1.3.6.1.2.1.15.3.1.9.".$arr_index[$i]));
								print $arr_index[$i] . "!" . $as . "\n";
							}
						}
					}
				break;

				case "in":
					for ($i=0;($i<sizeof($arr_index));$i++) {
						for ($a=0;$a<=$maxif;$a++) {
							$errorgetmac=false;
							$monoid="1.3.6.1.2.1.4.22.1.2.".$a.".".$arr_index[$i];
							$PhysAddress=@snmpget($hostname, $snmp_community, $monoid);
							if ($PhysAddress == FALSE) $errorgetmac=true;
							if ($errorgetmac == false) {
								$PhysAddress=eregi_replace("STRING: ","",$PhysAddress);
								$adrmac=macaddr($PhysAddress);
								$traffic=false;
								$traffic=@snmpget($hostname, $snmp_community, "1.3.6.1.4.1.9.9.84.1.2.1.1.4.".$a.".1.".$adrmac);
								if ($traffic == true) { $traffic=eregi_replace("Counter32: ","",$traffic); print $arr_index[$i] . "!" . $traffic."\n"; break; }
							}
						}
					}
				break;

				case "out":
					for ($i=0;($i<sizeof($arr_index));$i++) {
						for ($a=0;$a<=$maxif;$a++) {
							$errorgetmac=false;
							$monoid="1.3.6.1.2.1.4.22.1.2.".$a.".".$arr_index[$i];
							$PhysAddress=@snmpget($hostname, $snmp_community, $monoid);
							if ($PhysAddress == FALSE) $errorgetmac=true;
							if ($errorgetmac == false) {
								$PhysAddress=eregi_replace("STRING: ","",$PhysAddress);
								$adrmac=macaddr($PhysAddress);
								$traffic=false;
								$traffic=@snmpget($hostname, $snmp_community, "1.3.6.1.4.1.9.9.84.1.2.1.1.4.".$a.".2.".$adrmac);
								if ($traffic == true) { $traffic=eregi_replace("Counter32: ","",$traffic); print $arr_index[$i] . "!" . $traffic."\n"; break; }
							}
						}
					}
				break;
			}
		break;

		case "get":
			$arg = $arg1;
			$index = $arg2;

			switch ($arg) {
				case "in":
					for ($a=0;$a<=$maxif;$a++) {
						$errorgetmac=false;
						$monoid="1.3.6.1.2.1.4.22.1.2.".$a.".".$index;
						$PhysAddress=@snmpget($hostname, $snmp_community, $monoid);
						if ($PhysAddress == FALSE) $errorgetmac=true;
						if ($errorgetmac == false) {
							$PhysAddress=eregi_replace("STRING: ","",$PhysAddress);
							$adrmac=macaddr($PhysAddress);
							$traffic=false;
							$traffic=@snmpget($hostname, $snmp_community, "1.3.6.1.4.1.9.9.84.1.2.1.1.4.".$a.".1.".$adrmac);
							if ($traffic == true) { $traffic=eregi_replace("Counter32: ","",$traffic); print $traffic; break; }
						}
					}
				break;

				case "out":
					for ($a=0;$a<=$maxif;$a++) {
						$errorgetmac=false;
						$monoid="1.3.6.1.2.1.4.22.1.2.".$a.".".$index;
						$PhysAddress=@snmpget($hostname, $snmp_community, $monoid);
						if ($PhysAddress == FALSE) $errorgetmac=true;
						if ($errorgetmac == false) {
							$PhysAddress=eregi_replace("STRING: ","",$PhysAddress);
							$adrmac=macaddr($PhysAddress);
							$traffic=false;
							$traffic=@snmpget($hostname, $snmp_community, "1.3.6.1.4.1.9.9.84.1.2.1.1.4.".$a.".2.".$adrmac);
							if ($traffic == true) { $traffic=eregi_replace("Counter32: ","",$traffic); print $traffic; break; }
						}
					}
				break;

				case "index":
					echo $index;
				break;
			 }
		break;
	}
}

function ss_host_mac_reindex($arr) {
	$return_arr = array();

	for ($i=0;($i<sizeof($arr));$i++) {
		$return_arr[$i] = $arr[$i]["value"];
	}

	return $return_arr;
}


?>
